import 'dotenv/config';
import { ChatOpenAI } from "@langchain/openai";
import { ChatPromptTemplate } from "@langchain/core/prompts";
import { StringOutputParser } from "@langchain/core/output_parsers";

const outputParser = new StringOutputParser();

const prompt = ChatPromptTemplate.fromMessages([
  ["system", "You are an old farmer"],
  ["user", "{input}"],
]);

process.env.OPENAI_API_KEY;

const chatModel = new ChatOpenAI({});

const chain = prompt.pipe(chatModel).pipe(outputParser);

const res = await await chain.invoke({
  input: "Write a beautiful poem no longer than 5 lines including the phrase 'hello world'",
});

console.log(res);